//§§§

#if GPS_PROTOCOL == 6




/****************************************************************
 * Parsing stuff for the FlightGear simulator version
 * Jean-Louis Naudin - dec 9, 2009
 * For ArduPilot 2.7.3 Matti Rytkonen 2010-08-02
 ****************************************************************/


void print_data_emulator(void)  // Output Datalink for the Flight Gear gateway
{
  static unsigned long timer3 = 0;

  if(millis()-timer3 > 100)  // Output Rate for FGS set to every 500 ms
  {  
    Serial.print("!!!");
    Serial.print (",WPN:");
    Serial.print((int)wp_index);  //This is the target waypoint.
    Serial.print (",DST:");
    Serial.print(wp_distance);
    Serial.print (",BER:");
    Serial.print(target_bearing/100,DEC); //nav_bearing?
    Serial.print(",LAT:");
    Serial.print(current_loc.lat/100);
    Serial.print(",LON:");
    Serial.print(current_loc.lng/100); 
    Serial.print (",PHI:");
    Serial.print(phi);
    Serial.print (",THE:");
    Serial.print(theta);
    Serial.print (",SPD:");
    float floatGroundSpeed = (float)ground_speed;
    Serial.print(floatGroundSpeed);    
    Serial.print (",MSL:");
    float floatALT = (float)current_loc.alt;
    floatALT = floatALT / 100;
    Serial.print(floatALT);
    Serial.print (",RLL:");        // send the requested ROLL to the Flight Gear gateway

    Serial.print (nav_roll/100);    



    Serial.print (",PCH:");        // send the requested PITCH to the Flight Gear gateway
    
    
    
    Serial.print (nav_pitch/100);





    Serial.print (",THR:");       
    //    Serial.print((long)servo_throttle);
    Serial.print (servo_out[CH_THROTTLE]);
    Serial.print (",GPS:");
    Serial.print(sim_gps_mode);
    Serial.print (",ACK:");        // send Acknowledge of the command to the Flight Gear gateway
    Serial.print(ack);
    Serial.println(",***");

    timer3=millis(); 


  }
}

void decodeFGS(void) // decode the uplink datas from the Flight Gear gateway
{
  static char buffer[250]; //The traditional SERIAL buffer.
  static int counter=0; //Traditional counter

  while(Serial.available() > 0) //Check and loop while any byte is in the Serial Buffer. 
  {

    buffer[counter]=Serial.read();//Reading the byte

    if(buffer[counter]==0x0A)//Looks for \F, if not jump and continue receveing. 
    {

      if (strncmp (buffer,"&&&",3) == 0) //Looks for the && header
      {
        FGmode = Search_Int(buffer,"MOD:");
        FGlat = Search_Long(buffer,"LAT:");//Searching for the string LAT:, and converting/storing the value next to it. 
        FGlon = Search_Long(buffer,"LON:"); //The same
        current_loc.lat = FGlat*100;
        current_loc.lng = FGlon*100;
        current_loc.alt = Search_Long(buffer,"ALT:")  ; 
                current_loc.alt =     current_loc.alt*100;
        asp = Search_Int(buffer,"ASP:");
        airspeed = Search_Int(buffer,"ASP:") * 100;
        ground_speed = Search_Int(buffer,"GSP:") * 100;
        phi = Search_Float(buffer,"PHI:");
        roll_sensor = phi * 100;
        theta = Search_Float(buffer,"THE:");
        pitch_sensor = theta * 100;
        ground_course = Search_Long(buffer,"GCS:");
        ground_course = ground_course*100;



        if(current_loc.lat == 0){
          GPS_new_data = false;
          GPS_fix = BAD_GPS;
          sim_gps_mode=0;
        }
        else       { 
          GPS_new_data = true;
          GPS_fix=VALID_GPS; 
          sim_gps_mode=1;
        }



      }

      for(int a=0; a<=counter; a++)//restarting the buffer
      {
        buffer[a]=0; //Clearing the buffer.
      } 
      counter=0; //Restarting the counter. 
    }
    else
    {
      counter++;//Incrementing the counter
    }

    if(counter >= 250)
    {
      for(int a=0; a<=counter; a++)//restarting the buffer
      {
        buffer[a]=0; //Clearing the buffer.
      } 
      counter=0; //Restarting the counter. 
      break;
    }
  }
}

void init_gps(void)
{
}
void fast_init_gps(void)
{
}

void decode_gps(void)
{
}


// Here some functions from the Ardustation program

//Very important functions:
float Search_Float(char buffer[],char looking[])
{
  char *BufferPointer=buffer;
  char *SearchString;
  SearchString= strstr (BufferPointer,looking); 
  return atof(SearchString+4);
}

int Search_Int(char buffer[],char looking[])
{
  char *BufferPointer=buffer;
  char *SearchString;
  SearchString= strstr (BufferPointer,looking); 
  return atoi(SearchString+4);
}

long Search_Long(char buffer[],char looking[])
{
  char *BufferPointer=buffer;
  char *SearchString;
  SearchString= strstr (BufferPointer,looking); 
  return atol(SearchString+4);
}

#endif


//§§§

