#if GCS_PROTOCOL == 3
// An Xplane GCS

byte buf_len = 0;
byte out_buffer[32];

void output_Xplane(void)
{
	// output real-time sensor data
	Serial.print("AAA"); 		 						// 		Message preamble
	output_int((int)(servo_out[CH_ROLL]*100));			// 	0	bytes 0,1
	output_int((int)(servo_out[CH_PITCH]*100));			// 	1	bytes 2,3
	output_int((int)(servo_out[CH_THROTTLE]/1.25));		// 	2	bytes 4,5
	output_int((int)wp_distance);						// 	3	bytes 6,7
	output_int((int)bearing_error);						// 	4	bytes 8,9
	output_int((int)altitude_error);					// 	5	bytes 10,11
	output_int((int)energy_error);						// 	6	bytes 12,13
	output_byte(wp_index);								// 	7	bytes 14
	output_byte(control_mode);							// 	8	bytes 15
	
	// print out the buffer and checksum
	// ---------------------------------
	print_buffer();
}

void output_Xplane_(void)
{
	// output real-time sensor data
	Serial.print("AAA"); 		 						// 		Message preamble
	output_int((int)(servo_out[CH_ROLL]*100));			// 	0	bytes 0,1
	output_int((int)(servo_out[CH_PITCH]*100));			// 	1	bytes 2,3
	output_int((int)(servo_out[CH_THROTTLE]/1.25));		// 	2	bytes 4,5
	output_int((int)next_WP.alt);						// 	3	bytes 6,7
	output_int((int)offset_altitude);						// 	4	bytes 8,9
	output_int((int)altitude_error);					// 	5	bytes 10,11
	output_int((int)target_altitude);						// 	6	bytes 12,13
	output_byte(wp_index);								// 	7	bytes 14
	output_byte(control_mode);							// 	8	bytes 15
		
	// print out the buffer and checksum
	// ---------------------------------
	print_buffer();
}

void pipe()
{
	Serial.print("|");
}

void output_int(int value)
{
	//buf_len += 2;
	out_buffer[buf_len++]	= value & 0xff;
	out_buffer[buf_len++]	= (value >> 8) & 0xff;
}
void output_byte(byte value)
{
	out_buffer[buf_len++]	= value;
}

void print_buffer()
{
	byte ck_a = 0;
	byte ck_b = 0;
	for (byte i = 0;i < buf_len; i++){
		Serial.print (out_buffer[i]);
	}
	Serial.print('\r');
	Serial.print('\n');
	buf_len = 0;
	
	/*
	for (byte i = 0;i < length; i++){
		ck_a += out_buffer[i];	//Calculates checksums
		ck_b += ck_a;
	}
	Serial.print(ck_a);
	Serial.print(ck_b);
	*/
}

// required by Groundstation to plot lateral tracking course 
void print_new_wp_info()
{
}

void print_control_mode(void)
{
	switch (control_mode){
		case MANUAL:
			Serial.println("##MANUAL");
			break;
		case STABILIZE:
			Serial.println("##STABILIZE");
			break;
		case CIRCLE:
			Serial.println("##CIRCLE");
			break;
		case FLY_BY_WIRE_A:
			Serial.println("##FBW A");
			break;
		case FLY_BY_WIRE_B:
			Serial.println("##FBW B");
			break;
		case AUTO:
			Serial.println("##AUTO");
			break;
		case RTL:
			Serial.println("##RTL");
			break;
		case LOITER:
			Serial.println("##LOITER");
			break;
		case TAKEOFF:
			Serial.println("##TAKEOFF");
			break;
		case LAND:
			Serial.println("##LAND");
			break;
	}
}


void print_current_waypoints()
{
	Serial.print("PWP:");
	Serial.print("\t");
	Serial.print(prev_WP.lat,DEC);
	Serial.print(",\t");
	Serial.print(prev_WP.lng,DEC);
	Serial.print(",\t");
	Serial.println(prev_WP.alt,DEC);

	Serial.print("CUR:");
	Serial.print("\t");
	Serial.print(current_loc.lat,DEC);					
	Serial.print(",\t");
	Serial.print(current_loc.lng,DEC);					
	Serial.print(",\t");
	Serial.println(current_loc.alt,DEC);					
	
	Serial.print("NWP:");
	Serial.print(wp_index,DEC);
	Serial.print(",\t");
	Serial.print(next_WP.lat,DEC);
	Serial.print(",\t");
	Serial.print(next_WP.lng,DEC);
	Serial.print(",\t");
	Serial.println(next_WP.alt,DEC);
}

void print_position(void)
{
}

void printPerfData(void)
{
}

void print_attitude(void)
{
}
void print_tuning(void) {
}

#endif