// swing the servos around to show them we're alive
// ------------------------------------------------
void demo_servos()
{
	int temp = servo_out[CH_THROTTLE];
	servo_out[CH_THROTTLE] = 0;
	update_throttle();
	set_servo_mux(true);
	OCR1A = 1600 * 2;
	OCR1B = 1600 * 2;
	delay(400);
	OCR1A = 1400 * 2;
	OCR1B = 1400 * 2;
	delay(200);
	OCR1A = 1500 * 2;
	OCR1B = 1500 * 2;
	set_servo_mux(false);
	servo_out[CH_THROTTLE] = temp;
	update_throttle();

}

void set_servo_mux(boolean mode)
{
  
  
  
//§§§
#if GPS_PROTOCOL == 6
#else
//§§§

	while(TCNT1 < 20000){};
	if (mode){
		//take over the MUX
		pinMode(4, OUTPUT);
		digitalWrite(4, HIGH);
	}else{
		//release the MUX to allow Manual Control
		digitalWrite(4, LOW); 
		pinMode(4, INPUT);
	}
//§§§
#endif
//§§§

}
// wants +- 45°
void set_servos()
{
	#if GPS_PROTOCOL == 3
		if(imu_ok == false && control_mode > MANUAL){	        //  We have lost the IMU - Big trouble
			servo_out[CH_ROLL] = 0;   											//  If we have lost imu we will probably crash.  
			servo_out[CH_PITCH] = 0;											//  Neutralize controls, throttle off
			servo_out[CH_THROTTLE] = 0;
		}   
	#endif

#if MIXING_MODE == 0
	set_ch1_degrees(servo_out[CH_ROLL]); // 45 ° = right turn (unless reversed)
	set_ch2_degrees(servo_out[CH_PITCH]);
#endif

  /*Elevon mode*/ // 
#if MIXING_MODE == 1
	set_ch1_degrees(REVERSE_ELEVONS * (servo_out[CH_PITCH] - servo_out[CH_ROLL]));	
	set_ch2_degrees(servo_out[CH_PITCH] + servo_out[CH_ROLL]);
#endif

	update_throttle();
}



// requires +- 45°
void set_ch1_degrees(float deg){

#if MIXING_MODE == 0
	radio_out[CH_ROLL] = radio_trim[CH_ROLL] + ((float)REVERSE_ROLL * deg * 11.111f);
#endif

#if MIXING_MODE == 1
	radio_out[CH_ROLL] =  elevon1_trim + ((float)REVERSE_CH1_ELEVON  * deg * 11.111f);    //
#endif
	radio_out[CH_ROLL] = constrain(radio_out[CH_ROLL], 	radio_min[CH_ROLL], 	radio_max[CH_ROLL]);
	radio_out[CH_ROLL] = constrain(radio_out[CH_ROLL], 	1000, 	2000);
	OCR1A = radio_out[CH_ROLL] * 2;	//OCR1A is the channel 1 pulse width in half microseconds
}


void set_ch2_degrees(float deg){

#if MIXING_MODE == 0
	radio_out[CH_PITCH] = radio_trim[CH_PITCH] + ((float)REVERSE_PITCH * deg * 11.111f);
#endif

#if MIXING_MODE == 1
	radio_out[CH_PITCH] =  elevon2_trim + ((float)REVERSE_CH2_ELEVON * deg * 11.111f);   //
#endif
	radio_out[CH_PITCH] = constrain(radio_out[CH_PITCH], 	radio_min[CH_PITCH], 	radio_max[CH_PITCH]);
	radio_out[CH_PITCH] = constrain(radio_out[CH_PITCH], 	1000, 	2000);
	OCR1B = radio_out[CH_PITCH] * 2;
}

// sets the throttle timer value based on throttle percent
// -------------------------------------------------------
void update_throttle()
{
	#if(THROTTLE_SLEW_LIMIT != 0)
		servo_out[CH_THROTTLE] = throttle_slew_limit(servo_out[CH_THROTTLE]);
	#endif

	if (control_mode >= FLY_BY_WIRE_B){
		servo_out[CH_THROTTLE] = constrain(servo_out[CH_THROTTLE], THROTTLE_MIN, THROTTLE_MAX);
	}else{
		servo_out[CH_THROTTLE] = constrain(servo_out[CH_THROTTLE], 0, 125);
	}
	//Serial.print("\tT out :");
	//Serial.print(servo_out[CH_THROTTLE],DEC);
	//Serial.print("\tT r3 Min :");
	//Serial.print(ch3_timer_min,DEC);
	
	int temp = servo_out[CH_THROTTLE] + ch3_timer_min;
	//Serial.print("\tT temp b4 :");
	//Serial.print(temp,DEC);
	temp = constrain(temp, ch3_timer_min, 250);
	
	#if THROTTLE_OUT == 1
		OCR2A = temp;
	#else
		OCR2A = 125;
	#endif
	
	//Serial.print("\tT OCR2A :");
	//Serial.print(OCR2A,DEC);
	//Serial.print("\ttemp out :");
	//Serial.println(temp,DEC);
	
	// output for the groundstation
	// ----------------------------
	radio_out[CH_THROTTLE] = temp * 8;
}

// Throttle Timer Interrupt
// ------------------------
ISR(TIMER1_CAPT_vect) // Timer/Counter1 Capture Event
{
	//This is a timer 1 interrupts, executed every 20us 
	TCNT2 = 0; //restarting the counter of timer 2
	PORTB |= 0x01; //Putting the pin high!
}

ISR(TIMER2_COMPA_vect) // Timer/Counter2 Compare Match A
{
	// called when TCNT2 == 125:250 which equals 1000 - 2000µs
	// the counter will increment 1 every 8µs
	PORTB &= 0xFE;//Putting the pin low
}

void init_PWM()
{
	// Servo setup
	// -----------
	
	// Timer 1
	TCCR1A = ((1<<WGM11) | (1<<COM1B1) | (1<<COM1A1)); //Fast PWM: ICR1=TOP, OCR1x=BOTTOM,TOV1=TOP
	TCCR1B = (1<<WGM13) | (1<<WGM12) | (1<<CS11); // Clock scaler = 8, 2,000,000 counts per second
	OCR1A = 3000;	// Rudder  - multiply your value * 2; for example 3000 = 1500 = 45°; 4000 = 2000 = 90°
	OCR1B = 3000; 	// Elevator
	ICR1 = 40000; 	//50hz freq...Datasheet says	(system_freq/prescaler)/target frequency. So (16000000hz/8)/50hz = 40000,

	// throttle;
	//Setting up the Timer 2 - 8 bit timer
	TCCR2A 	= _BV(WGM21); //CTC mode 
	TCCR2B 	= _BV(CS20)|_BV(CS22); //prescaler 128, at 16mhz (128/16) = 8, the counter will increment 1 every 8us
	ch3_timer_min = 125 + ch3_timer_trim;
	OCR2A 	= radio_min[CH_THROTTLE]; //1500us/8; The top, when the counter reaches the value definied here will execute the interrupt, 187 is the servo centered... 
	TIMSK1 |= _BV(ICIE1); 	// Timer/Counter1, Input Capture Interrupt Enable //PB0 - output throttle
	TIMSK2 	= _BV(OCIE2A);	// Timer/Counter2 Compare Match A

	for(int c=0; c < 30; c++){
		delay(20);
		read_radio();
	}	
}

